Index: uspace/app/barber/barber.c
===================================================================
--- uspace/app/barber/barber.c	(revision bdf06ad0e1ef4d9fbaef8b55192ac6aa52fac64a)
+++ uspace/app/barber/barber.c	(revision 442210e20a8b7bf587b3c36dc5fa35dce6378148)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2024 Jiri Svoboda
+ * Copyright (c) 2020 Jiri Svoboda
  * Copyright (c) 2014 Martin Decky
  * All rights reserved.
@@ -50,5 +50,4 @@
 #include <ui/image.h>
 #include "images.h"
-#include "images_tiny.h"
 
 #define NAME  "barber"
@@ -61,4 +60,7 @@
 #define MIN_LOAD  (LOAD_UNIT / 4)
 #define MAX_LOAD  (LOAD_UNIT / 3)
+
+#define FRAME_WIDTH   59
+#define FRAME_HEIGHT  192
 
 #define LED_PERIOD  1000000
@@ -95,6 +97,4 @@
 static unsigned int frame = 0;
 static unsigned int fps = MIN_FPS;
-static gfx_coord_t frame_width;
-static gfx_coord_t frame_height;
 
 static void led_timer_callback(void *);
@@ -102,9 +102,7 @@
 
 static void wnd_close(ui_window_t *, void *);
-static void wnd_kbd_event(ui_window_t *, void *, kbd_event_t *);
 
 static ui_window_cb_t window_cb = {
-	.close = wnd_close,
-	.kbd = wnd_kbd_event
+	.close = wnd_close
 };
 
@@ -112,5 +110,5 @@
  *
  * @param window Window
- * @param arg Argument (barber)
+ * @param arg Argument (launcher)
  */
 static void wnd_close(ui_window_t *window, void *arg)
@@ -121,50 +119,5 @@
 }
 
-/** Barber unmodified key press.
- *
- * @param barber Barber
- * @param event Keyboard event
- */
-static void barber_kbd_event_unmod(barber_t *barber, kbd_event_t *event)
-{
-	if (event->key == KC_ESCAPE)
-		ui_quit(barber->ui);
-}
-
-/** Barber ctrl-key key press.
- *
- * @param barber Barber
- * @param event Keyboard event
- */
-static void barber_kbd_event_ctrl(barber_t *barber, kbd_event_t *event)
-{
-	if (event->key == KC_Q)
-		ui_quit(barber->ui);
-}
-
-/** Barber window keyboard event.
- *
- * @param window UI window
- * @param arg Argument (barber_t *)
- * @param event Keyboard event
- */
-static void wnd_kbd_event(ui_window_t *window, void *arg, kbd_event_t *event)
-{
-	barber_t *barber = (barber_t *)arg;
-
-	if (event->type != KEY_PRESS)
-		return;
-
-	if ((event->mods & (KM_CTRL | KM_ALT | KM_SHIFT)) == 0)
-		barber_kbd_event_unmod(barber, event);
-
-	if ((event->mods & KM_CTRL) != 0 &&
-	    (event->mods & (KM_ALT | KM_SHIFT)) == 0)
-		barber_kbd_event_ctrl(barber, event);
-
-	ui_window_def_kbd(window, event);
-}
-
-static bool decode_frames(gfx_context_t *gc, image_t *img)
+static bool decode_frames(gfx_context_t *gc)
 {
 	gfx_rect_t rect;
@@ -172,5 +125,5 @@
 
 	for (unsigned int i = 0; i < FRAMES; i++) {
-		rc = decode_tga_gz(gc, img[i].addr, img[i].size,
+		rc = decode_tga_gz(gc, images[i].addr, images[i].size,
 		    &frame_bmp[i], &rect);
 		if (rc != EOK) {
@@ -179,5 +132,5 @@
 		}
 
-		(void)rect;
+		(void) rect;
 	}
 
@@ -285,6 +238,6 @@
 	rect.p0.x = 0;
 	rect.p0.y = 0;
-	rect.p1.x = frame_width;
-	rect.p1.y = frame_height;
+	rect.p1.x = FRAME_WIDTH;
+	rect.p1.y = FRAME_HEIGHT;
 
 	ui_image_set_bmp(frame_img, frame_bmp[frame], &rect);
@@ -346,5 +299,5 @@
 int main(int argc, char *argv[])
 {
-	const char *display_spec = UI_ANY_DEFAULT;
+	const char *display_spec = UI_DISPLAY_DEFAULT;
 	barber_t barber;
 	ui_t *ui;
@@ -357,5 +310,4 @@
 	gfx_context_t *gc;
 	gfx_coord2_t off;
-	image_t *img;
 	int i;
 
@@ -403,19 +355,11 @@
 	}
 
-	if (ui_is_textmode(ui)) {
-		frame_width = 10;
-		frame_height = 16;
-	} else {
-		frame_width = 59;
-		frame_height = 192;
-	}
-
 	rect.p0.x = 0;
 	rect.p0.y = 0;
-	rect.p1.x = frame_width;
-	rect.p1.y = frame_height;
+	rect.p1.x = FRAME_WIDTH;
+	rect.p1.y = FRAME_HEIGHT;
 
 	ui_wnd_params_init(&params);
-	params.caption = "Barber Pole";
+	params.caption = "";
 	params.placement = ui_wnd_place_bottom_right;
 	/*
@@ -423,5 +367,5 @@
 	 * to rect
 	 */
-	ui_wdecor_rect_from_app(ui, params.style, &rect, &wrect);
+	ui_wdecor_rect_from_app(params.style, &rect, &wrect);
 	off = wrect.p0;
 	gfx_rect_rtranslate(&off, &wrect, &params.rect);
@@ -440,7 +384,5 @@
 	ui_window_set_cb(window, &window_cb, (void *) &barber);
 
-	img = ui_is_textmode(ui) ? image_tinys : images;
-
-	if (!decode_frames(gc, img))
+	if (!decode_frames(gc))
 		return 1;
 